@echo off
cls
echo.
echo ver- und entschlsseln mit openssl
echo.
:start
	set /P w=mchten Sie eine Datei [v]er- oder [e]ntschlsseln?
	if /I "%w%"=="v" goto verschl
	if /I "%w%"=="e" goto entschl
	echo Fehler: [%w%]
goto start

:verschl
	echo.
	echo verschlsseln mit openssl
	echo.
	set /p Name=Bitte Dateiname eingeben:
	set /p passwort=Bitte beliebiges Passwort eingeben:
	openssl enc -aes256 -e -in %Name% -out %Name%.openssl -k %passwort%
	if %errorlevel% NEQ 0 GOTO verschl
	echo %passwort%>%Name%.openssl.pin
	echo.
	echo Die Datei %Name% wurde verschlsselt und unter dem Namen %Name%.openssl abgespeichert
	echo.
	goto pindatei

	:pindatei
	    echo das passwort wurde in der Datei %Name%.openssl.pin abgespeichert
	    set /P w= Pindatei loeschen [j]a / [n]ein?
	    if /I "%w%"=="j" goto loeschen
	    if /I "%w%"=="n" goto ende
	    echo Fehler: [%w%]
	goto pindatei

	:loeschen
		del /Q %Name%.openssl.pin
		ECHO Datei gelscht
	goto ende
goto ende

:entschl
echo.
echo entschlsseln mit openssl
echo.
:start_entschl
	set /P w=Pindatei vorhanden [j]a / [n]ein?
	if /I "%w%"=="j" goto Pindatei
	if /I "%w%"=="n" goto Passwort
	echo Fehler: [%w%]
goto start_entschl

:Passwort
	set /p Name=Bitte Dateiname der verschl. Datei eingeben:
	set /p passwort=Bitte Passwort zum Entschlsseln eingeben:
	set Dateiname=%Name:~0,-8%
	openssl enc -aes256 -d -in %Name% -out %Dateiname% -k %passwort%
	if %errorlevel% NEQ 0 GOTO Passwort
goto ende_entschl


:Pindatei
	set /p Name=Bitte Dateiname der verschl. Datei eingeben:
	set Dateiname=%Name:~0,-8%
	set /p pind=Pindatei %Name%.pin die richtige Pindatei [j]a / [n]ein?
	if /I "%pind%"=="n" set /P pindat=Bitte PIN-Dateiname der verschl. Datei eingeben:
	if /I "%pind%"=="j" set pindat=%Name%.pin
	echo Pindatei %pindat% wird verwendet
	openssl enc -aes256 -d -in %Name% -out %Dateiname% -kfile %pindat%
	if %errorlevel% NEQ 0 GOTO Pindatei
goto ende_entschl

:ende_entschl
echo Die Datei %Name% wurde entschlsselt und unter dem Namen %Dateiname% gespeichert
goto ende

:ende
echo.
echo Aktion abgeschlossen
ping -n 6 127.0.0.1 >nul